#ifndef _LIB_LCD_H
#define _LIB_LCD_H

#include "derivative.h"

#define LCD_CONFIG  LCDC0_LCDEN = 0
#define LCD_DISPLAY LCDC0_LCDEN = 1

#define LCD_CLK_EX  LCDC0_SOURCE = 0
#define LCD_CLK_FF  LCDC0_SOURCE = 1

#define LCD_CP_EN   LCDSUPPLY_CPSEL = 0x1
#define LCD_CP_DIS  LCDSUPPLY_CPSEL = 0x0

#define LCD_DUTY_1_1  LCDC0_DUTY = 0
#define LCD_DUTY_1_2  LCDC0_DUTY = 1
#define LCD_DUTY_1_3  LCDC0_DUTY = 2
#define LCD_DUTY_1_4  LCDC0_DUTY = 3
#define LCD_DUTY_1_5  LCDC0_DUTY = 4
#define LCD_DUTY_1_6  LCDC0_DUTY = 5
#define LCD_DUTY_1_7  LCDC0_DUTY = 6
#define LCD_DUTY_1_8  LCDC0_DUTY = 7

#define LCD_ACTIVE_WAIT   LCDC1_LCDWAI = 0
#define LCD_INACTIVE_WAIT LCDC1_LCDWAI = 1

#define LCD_ACTIVE_STOP   LCDC1_LCDSTP = 0
#define LCD_INACTIVE_STOP LCDC1_LCDSTP = 1

#define LCD_INT_EN  LCDC1_LCDIEN = 1
#define LCD_INT_DIS LCDC1_LCDIEN = 0

#define LCD_INT_CLEAR LCDS_LCDIF = 1

#define BRATE_0 0x0
#define BRATE_1 0x1
#define BRATE_2 0x2
#define BRATE_3 0x3
#define BRATE_4 0x4
#define BRATE_5 0x5
#define BRATE_6 0x6
#define BRATE_7 0x7

#define BLINK_EN  0x80
#define BLINK_DIS 0x00

#define ALT_DISPLAY 0x40
#define NOR_DISPLAY 0x00

#define BLANK_DISPLAY   0x20
#define NOR_ALT_DISPLAY 0x00

#define BLINK_ALT   0x8
#define BLINK_BLANK 0x0

extern const byte ascii[];

extern byte Display_Buf[14];

extern void LCD_WF_init(void);

extern void LCD_pos(byte pos, byte display);

extern void LCD_pos_buf(byte pos, byte display);

extern void LCD_Buf_WF(void);

#endif